/*
**	  GPU Raytrace - Diploma thesis, Czech technical university
**	  Copyright (C) 2008 Martin Zlatuska
**
**	  This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#pragma once

#include <map>
#include <string>
#include <string.h>

using namespace std;

enum Token {LEX_EOF,LEX_NUMBER,
		    LEX_OPEN_CURLY,LEX_CLOSE_CURLY,LEX_OPEN_BRACKET,LEX_CLOSE_BRACKET,LEX_SEMICOLON,LEX_COMMA,
			LEX_SEPARATOR,
			LEX_SHAPE_HINTS,LEX_SHAPE_TYPE,LEX_UNKNOWN_SHAPE_TYPE,LEX_FACE_TYPE,LEX_UNKNOWN_FACE_TYPE,
			LEX_MATERIAL,LEX_AMBIENT_COLOR,LEX_DIFFUSE_COLOR,LEX_EMISSIVE_COLOR,LEX_SPECULAR_COLOR,LEX_SHININESS,LEX_TRANSPARENCY,
			LEX_INDEXED_MESH,LEX_VERTEX_PROPERTY_VARIABLE,LEX_VERTEX_PROPERTY_CLASS,LEX_VERTEX,
			LEX_NORMAL,LEX_NORMAL_BINDING,LEX_MATERIAL_BINDING,LEX_NORMAL_BINDING_PER_VERTEX_INDEXED,LEX_MATERIAL_BINDING_OVERALL,
			LEX_COORD_INDEX,LEX_NORMAL_INDEX
};

class UnknownKeyword {
};
			
class Lexan {
protected:
	int	  redInteger;
	float redFloat;

    char *text;
    char *currentText;	

	map<string,Token> 		tokenMap;		//Token identifier
    
    void eatWhite() {while(*text && (*text==' ' || *text=='\n')) text++;};	//Skip all white space characters

    bool isTextChar(char ch) {return (ch>='a' && ch<='z') || (ch>='A' && ch<='Z') || (ch>='0' && ch<='9') || ch=='_';};	//Return true if character is text character
    bool isNumber(char ch)   {return (ch>='0' && ch<='9') || ch=='-' ;};										//Return true if character is number

    Token identKeyword();				//Try to Identify keyword in text
    Token getToken(bool wantInteger);	//Retreive next token from input text

public:
    Lexan() {};
    ~Lexan(void) {};

    void setText(char *newText);	//Set new text for parser
};
