#pragma once

#include <wx/wx.h>

#include "TextureDisplay.h"

struct Resolution {
	unsigned width;
	unsigned height;
};

class MainWindow : public wxFrame {
protected:
	wxMenuBar	*menubar;
    wxMenu		*file;

	wxPanel		*settingsPanel;
	wxComboBox	*resolutionBox;
	wxComboBox	*structureBox;

	wxStaticText *frameTime;
	wxStaticText *fps;

	wxStatusBar	 *statusBar;

	wxToolBar* toolBar;
	wxToolBarToolBase *omni,*walk;
	int		   axisLast;

	TextureDisplay *canvas;

public:
	MainWindow(const wxString& title);
	~MainWindow(void);

	void OnQuit(wxCommandEvent& event);
	void OnFileOpen(wxCommandEvent& event);
	void OnResolutionChange(wxCommandEvent& event);
	void OnStructureChange(wxCommandEvent& event);

	void onViewMode(wxCommandEvent& event);
	void onMainAxis(wxCommandEvent& event);

	void setRenderTime(float time);

	TextureDisplay* getCanvas() {return canvas;};

	DECLARE_EVENT_TABLE()
};
