/*
**	  GPU Raytrace - Diploma thesis, Czech technical university
**	  Copyright (C) 2008 Martin Zlatuska
**
**	  This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <vector>
#include <cuda_runtime.h>

#include "Material.h"

MaterialManager* MaterialManager::objInstance = 0;

Material* MaterialManager::copyToCuda() {
	cudaMalloc((void**)&videoCopy,materials.size()*sizeof(Material));
	cudaMemcpy(videoCopy,&materials.front(),materials.size()*sizeof(Material),cudaMemcpyHostToDevice);	

	return videoCopy;
};

void MaterialManager::clearCuda() {
	cudaFree(videoCopy);
};
