/*
**	  GPU Raytrace - Diploma thesis, Czech technical university
**	  Copyright (C) 2008 Martin Zlatuska
**
**	  This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <stdio.h>

#include "Object.h"
#include "Material.h"

void Object::save(char* path) {
	FILE *output;
	output = fopen(path,"wb");

	std::vector<Material> &materials = MaterialManager::instance()->getMaterials();
	unsigned materialCount = materials.size();
	
	fwrite(&vertexCount		,4,1,output);
	fwrite(&facesCount		,4,1,output);
	fwrite(&materialCount	,4,1,output);

	for(unsigned i=0;i<materialCount;i++)
		fwrite(&(materials[i]),sizeof(Material),1,output);

	fwrite(&minimum ,16,1,output);
	fwrite(&maximum ,16,1,output);

	fwrite(vertices,16,vertexCount,output);
	fwrite(normal  ,16,vertexCount,output);
	fwrite(faces   ,16,facesCount ,output);

	fclose(output);
};

Object::~Object() {
	delete vertices;
	delete normal;
	delete faces;
};