/*
**	  GPU Raytrace - Diploma thesis, Czech technical university
**	  Copyright (C) 2008 Martin Zlatuska
**
**	  This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#pragma once

#include <stdio.h>

#include <vector_types.h>

#include "Transformations/animation.h"


class AnimationPath {
public:
	Animation* animation;

	float start,end;
	int	  framesCount;

	FILE *fp;

	void parseA();
	void parseAnimParams();
	void parseKeyFrames();
	void parseLight();
	void parseViewpoint();
	void parseComment();

public:
	AnimationPath(char* fileName);
	~AnimationPath(void);


	void GetCamera(double time,bool &gotPosition,float3 &viewPos,bool &gotDirection, float3 &viewDir, float3 &viewUp);
};
