/*----------------------------------------------------------------------
  File:    animation.h
  Purpose: functions and data structures for animation
           This file contains all functions you need to get the animted
           transform out of an struct AnimationList
----------------------------------------------------------------------*/

#ifndef ANIMATION_H
#define ANIMATION_H

#include "kbsplpos.h"
#include "kbsplrot.h"

typedef struct {
   char *name;
   void *translations;
   void *rotations;
   void *scales;
   void *visibilities;
   int numVisibilities;
} Animation;

Animation* FindAnimation(char* name,struct AnimationList *al);

bool _GetTranslation(Animation* animation, double time, double Tout[3]);
bool _GetRotation(Animation* animation, double time, double Rout[4]);
bool _GetScale(Animation* animation, double time, double Sout[3]);
void _GetMatrix(Animation* animation, double time, double m[4][4]);

bool GetTranslation(struct AnimationList *al,char* name, double time, double Tout[3]);
bool GetRotation(struct AnimationList *al,char* name, double time, double Rout[4]);
bool GetScale(struct AnimationList *al,char* name, double time, double Sout[3]);
bool GetMatrix(struct AnimationList *al,char* name, double time, double m[4][4]);
void GetCamera(struct AnimationList *al,double time,
	       int *gotPosition,double viewPos[3],
	       int *gotDirection, double viewDir[3], double viewUp[3]);

#endif
