//////////////////////////////////////////////////////////////////////////////
//
// SPMATRIX.CPP
//
//  Implementation of the SPMatrix, SPVector and the SPVector3 classes.
//
//  Version 1.0
//  Written by Zvi Devir, Intel MSL
//
//////////////////////////////////////////////////////////////////////////////

//
//   Copyright (c) 2001 Intel Corporation.
//
// Permition is granted to use, copy, distribute and prepare derivative works 
// of this library for any purpose and without fee, provided, that the above 
// copyright notice and this statement appear in all copies.  
// Intel makes no representations about the suitability of this software for 
// any purpose, and specifically disclaims all warranties. 
// See LEGAL.TXT for all the legal information.
//

#include "SPMatrix.h"

const ALIGN16 int     __0FFF_[4] = { 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0x00000000 };
const ALIGN16 float __ZERONE_[4] = { 1.0f, 0.0f, 0.0f, 1.0f };

// ----------------------------------------------------------------------------
//  Name:   TranslateMatrix
//  Desc:   Returns the translation matrix for specific translation.
// ----------------------------------------------------------------------------
void SPMatrix::TranslateMatrix(const float dx, const float dy, const float dz)
{
    IdentityMatrix();
    _41 = dx;
    _42 = dy;
    _43 = dz;
} 

// ----------------------------------------------------------------------------
//  Name:   ScaleMatrix
//  Desc:   Returns the scaling matrix for x,y,z axis.
// ----------------------------------------------------------------------------
void SPMatrix::ScaleMatrix(const float a, const float b, const float c)
{
    IdentityMatrix();
    _11 = a;
    _22 = b;
    _33 = c;
} 