#define BUNNY
//#define SPHERES

//#define GRID
#ifdef GRID
#include <windows.h>
#include <gl/gl.h>
#include <gl/glut.h>

#include "FormatImport/PlyLoader.h"
#include "Partitoning/UniformGrid.h"

Object* bunny;
UniformGrid *grid;
unsigned *bla;

int x=56,y=32,z=17;
float angleX;

const float PI2  = 6.283185307179586476925286766559f;
const float PI2A = 57.295779513082320876798154814105f;

float eyex,eyey,eyez;
float dirx,diry,dirz;
float p1x,p1y,p1z;
float p2x,p2y,p2z;

void keyDown(unsigned char key, int q, int w) {
	switch(key) {
		case 'a': if(x>0)			 x--;	break;
		case 'd': if(x<grid->dimX-1) x++;	break;

		case 's': if(y>0)			 y--;	break;
		case 'w': if(y<grid->dimY-1) y++;	break;

		case 'e': if(z>0)			 z--;	break;
		case 'q': if(z<grid->dimZ-1) z++;	break;
	};

	glutPostRedisplay();
};

void keyDownSpec(int key, int q, int w) {
	switch(key) {
		case GLUT_KEY_LEFT:	 angleX+=0.1; if(angleX>=PI2) angleX-=PI2; break;
		case GLUT_KEY_RIGHT: angleX-=0.1; if(angleX<0)    angleX+=PI2; break;
	};
	glutPostRedisplay();
};

unsigned indices[] = {
	2531, 2595, 2596,
	2531, 2596, 2532,
	2532, 2596, 2597,
	2532, 2597, 2533,
	2533, 2597, 2598,
	2533, 2598, 2534,
	2534, 2598, 2599,
	2530, 2595, 2531};

void render() {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//gluPerspective(45.0,4.0/3.0,0.001f,4.0f);
	gluPerspective(45.0,4.0/3.0,1.0f,4000.0f);


	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();

	glScalef(-1.0f,1.0f,1.0f);

	glTranslatef(0.0f,150.0f,-200.0f);
	//glTranslatef(0.0f,-0.11f,-0.3f);
	//glTranslatef(0.0f,0.0f,-0.8f);
	//glTranslatef(0.26f,0.0f,-0.25f);
	glRotatef(angleX*PI2A,0.0f,1.0f,0.0f);

	//glTranslatef(0.0f,-0.10f,-0.075f);
	//glRotatef(angleX*PI2A,0.0f,1.0f,0.0f);

	//glTranslatef(0.0f,-0.11f,-0.05f);

	//glTranslatef(0.0f,-0.11f,-0.1f);

	//gluLookAt(eyex+0.25f*dirx,eyey+0.25f*diry,eyez+0.25f*dirz,eyex+dirx,eyey+diry,eyez+dirz,0.0f,1.0f,0.0f);

	glColor3f(1.0f,1.0f,1.0f);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	//glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

	glShadeModel(GL_FLAT);

	glEnable(GL_VERTEX_ARRAY);
	glEnable(GL_NORMAL_ARRAY);
	//glVertexPointer(4,GL_FLOAT,0,bunny->vertices);
	glVertexPointer(4,GL_FLOAT,0,grid->transformed);
	glNormalPointer(GL_FLOAT,16,grid->normals);
	glDrawElements(GL_TRIANGLES,grid->totalPoly*3,GL_UNSIGNED_INT,bla);

	/*glBegin(GL_TRIANGLES);
		for(int i=0;i<8*3;i++)
			glArrayElement(indices[i]);
	glEnd();*/

/*	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);

	glBegin(GL_TRIANGLES);
		glColor3f(1.0f,0.5f,0.25f);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159926].a].x);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159926].b].x);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159926].c].x);

		glColor3f(0.5f,0.25f,1.0f);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159850].a].x);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159850].b].x);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159850].c].x);

		glColor3f(0.25f,1.0f,0.5f);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159847].a].x);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159847].b].x);
		glVertex3fv(&grid->transformed[grid->cellTriangles[159847].c].x);
	glEnd();


	glColor3f(1.0f,0.0f,0.0f);
	float3 a;
	a.x = grid->cuMinimum.x + x*grid->cuCellSize;
	a.y = grid->cuMinimum.y + y*grid->cuCellSize;
	a.z = grid->cuMinimum.z + z*grid->cuCellSize;

	float3 s;
	s.x = grid->cuCellSize;
	s.y = grid->cuCellSize;
	s.z = grid->cuCellSize;

	float3 mi = grid->cuMinimum;
	float3 ma = grid->cuMaximum;
		 
	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

	//glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	glColor3f(0.0f,1.0f,0.0f);

	unsigned index = z*grid->dimX*grid->dimY + y*grid->dimX + x;
	unsigned count = grid->grid[index].count;
	if(count) {
		unsigned offset = grid->grid[index].offset;
		glBegin(GL_TRIANGLES);
		for(int i=0;i<count;i++) {
			unsigned a = grid->cellTriangles[offset].a;
			unsigned c = grid->cellTriangles[offset].b;
			unsigned b = grid->cellTriangles[offset].c;

			glVertex3fv(&grid->transformed[a].x);
			glVertex3fv(&grid->transformed[b].x);
			glVertex3fv(&grid->transformed[c].x);

			offset++;
		};
		glEnd();
	};

	glColor3f(1.0f,0.0f,0.0f);
	glBegin(GL_QUADS);
		glVertex3f(mi.x	,mi.y ,mi.z);
		glVertex3f(ma.x ,mi.y ,mi.z);
		glVertex3f(ma.x ,ma.y ,mi.z);
		glVertex3f(mi.x ,ma.y ,mi.z);
		

		glVertex3f(a.x		,a.y	  ,a.z);
		glVertex3f(a.x + s.x,a.y	  ,a.z);
		glVertex3f(a.x + s.x,a.y + s.y,a.z);
		glVertex3f(a.x      ,a.y + s.y,a.z);

		glVertex3f(a.x		,a.y	  ,a.z);
		glVertex3f(a.x + s.x,a.y	  ,a.z);
		glVertex3f(a.x + s.x,a.y	  ,a.z + s.z);
		glVertex3f(a.x      ,a.y	  ,a.z + s.z);
	glEnd();

	glColor3f(1.0f,1.0f,1.0f);
	glBegin(GL_LINES);
		glVertex3f(eyex,eyey,eyez);
		glVertex3f(eyex+dirx*2.0f,eyey+diry*2.0f,eyez+dirz*2.0f);
	glEnd();

	glColor3f(1.0f,0.0f,0.0f);

	glPointSize(5.0f);
	glBegin(GL_POINTS);
		glVertex3f(p1x,p1y,p1z);
		glVertex3f(p2x,p2y,p2z);
	glEnd();*/

	glutSwapBuffers();
};

int main(int argc,char** argv) {
	*(unsigned*)&eyex = 0x3f4ccccd;
	*(unsigned*)&eyey = 0x00000000;
	*(unsigned*)&eyez = 0x3e99999a;
	*(unsigned*)&dirx = 0xbf840cc4;
	*(unsigned*)&diry = 0xbba7d300;
	*(unsigned*)&dirz = 0xbdc69448;
	*(unsigned*)&p1x = 0xbe87a4aa;
	*(unsigned*)&p1y = 0xbbad3d51;
	*(unsigned*)&p1z = 0x3e4cb4e0;
	*(unsigned*)&p2x = 0xbe89e7ff;
	*(unsigned*)&p2y = 0xbbae1490;
	*(unsigned*)&p2z = 0x3e4c677a;

	PlyLoader loader;
	/*bunny = loader.loadFile("e:\\bun_zipper.ply");

	Transformation* trans = new Transformation();
	trans->IdentityMatrix();

	Scene scene;
	scene.push_back(ObjectInstance(trans,bunny));*/


/*	Object* bunny = loader.loadFile("e:\\sphere2.ply");
	Transformation* trans = new Transformation();
	trans->IdentityMatrix();
	trans->scale(0.5f,0.5f,0.5f);
	trans->translate(0.25f,0.0f,0.0f);

	Scene scene;
	scene.push_back(ObjectInstance(trans,bunny));

	trans = new Transformation();
	trans->IdentityMatrix();
	trans->translate(-0.25f,0.0f,0.0f);
	scene.push_back(ObjectInstance(trans,bunny));*/

	Scene* scene = SceneLoader::instance()->loadScene("e:\\robots.mdl");

	grid = new UniformGrid(*scene,64);

	bla = new unsigned[grid->totalPoly*3];
	for(int i=0;i<grid->totalPoly;i++) {
		bla[3*i] = grid->cellTriangles[i].a;
		bla[3*i+1] = grid->cellTriangles[i].b;
		bla[3*i+2] = grid->cellTriangles[i].c;
	};

	glutInit(&argc,argv);
	glutInitWindowSize(800,600);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("Visualisation");

	glutDisplayFunc(render);
	glutKeyboardFunc(keyDown);
	glutSpecialFunc(keyDownSpec);

	glutMainLoop();
};
#endif

#define KDVIS
#ifdef  KDVIS
#include <windows.h>
#include <gl/gl.h>
#include <gl/glut.h>

#include <iostream>
#include <cstdlib>
#include <ctime>

#include "FormatImport/PlyLoader.h"
#include "FormatImport/MyLoader.h"
#include "Partitoning/UniformGrid.h"
#include "Partitoning/KdTree.h"
#include "Camera.h"

using std::min;
using std::max;

Object* bunny;
KdTree* grid;
unsigned *bla;

int x=56,y=32,z=17;
float angleX;
float posZ = 0.0f;

const float PI2  = 6.283185307179586476925286766559f;
const float PI2A = 57.295779513082320876798154814105f;

float eyex,eyey,eyez;
float dirx,diry,dirz;
float p1x,p1y,p1z;
float p2x,p2y,p2z;

unsigned level = 0;
unsigned cellIndex  = 0;
unsigned cellTarget = 0;
//unsigned cellTarget = 50;

CameraCuda cameraCuda;

void keyDown(unsigned char key, int q, int w) {
	if(key == 'a') level--;
	if(key == 'd') level++;
	//if(key == 'w') posZ += 1.0f;
	//if(key == 's') posZ -= 1.0f;
	if(key == 'w') posZ += 0.1f;
	if(key == 's') posZ -= 0.1f;
	glutPostRedisplay();
};

void keyDownSpec(int key, int q, int w) {
	switch(key) {
		case GLUT_KEY_LEFT:	 angleX+=0.1; if(angleX>=PI2) angleX-=PI2; break;
		case GLUT_KEY_RIGHT: angleX-=0.1; if(angleX<0)    angleX+=PI2; break;
		case GLUT_KEY_UP   : cellTarget++; break;
		case GLUT_KEY_DOWN : cellTarget--; break;
	};
	glutPostRedisplay();
};

unsigned indices[] = {
	2531, 2595, 2596,
	2531, 2596, 2532,
	2532, 2596, 2597,
	2532, 2597, 2533,
	2533, 2597, 2598,
	2533, 2598, 2534,
	2534, 2598, 2599,
	2530, 2595, 2531};

#include <float.h>

struct Child {
	unsigned node;
	float3	 minimum;
	float3   maximum;
};

void intersectTexture(float3 &eye,float3 &dir,unsigned offset,float &u,float &v,float &t) {
	unsigned a=grid->nodeTriangles[offset]->a;
	unsigned b=grid->nodeTriangles[offset]->b;
	unsigned c=grid->nodeTriangles[offset]->c;
	
	SPVector v0 = grid->transformed[a];
	SPVector v1 = grid->transformed[b];
	SPVector v2 = grid->transformed[c];

	v2 -= v0;
	v1 -= v0;

	SPVector eye2(eye.x,eye.y,eye.z);
	SPVector dir2(dir.x,dir.y,dir.z);

	SPVector tvec   = eye2 - v0;
	SPVector pvec   = dir2 % v2;
	float  invDet = 1.0f / (v1*pvec);

	u = (tvec*pvec)*invDet;

	SPVector qvec = tvec % v1;
	t = (v2*qvec)*invDet;
	v = (dir2*qvec)*invDet;
};

unsigned maxDepth = 0;
unsigned triangleTests =0;
unsigned steps = 0;

unsigned traverse[1024];

int traverseKdTree(float3 &eye,float3 &dir,float3 &minimumIn ,float3 &maximumIn) {
	steps = 0;
	bool  outside = true;

	float tMin,tMax;
	float globalMax;

	float3 minimum = minimumIn;
	float3 maximum = maximumIn;

	unsigned stackNode[4];
	float	 stackMin [4];
	float	 stackMax [4];
	float3   stackExtMin[4];
	float3   stackExtMax[4];
	int stackStart = 0;
	int stackCount = 0;

	// Kay and Kayjia ray-box intersection test as descibed in "An introduction to Ray Tracing" by A.S.Glassner
	{
		float tMinX,tMinY,tMinZ;
		float tMaxX,tMaxY,tMaxZ;
		float temp;

		//Speed by division by using the resiprocal. 
		float3 rDir;
		rDir.x=1.0f/dir.x;
		rDir.y=1.0f/dir.y;
		rDir.z=1.0f/dir.z;

		tMinX = ( minimum.x - eye.x ) * rDir.x;
		tMaxX = ( maximum.x - eye.x ) * rDir.x;

		if(dir.x < 0) {		//Swap the values instead of computing in the branche. Should spend less time in divergent branches.
			temp  = tMinX;
			tMinX = tMaxX;
			tMaxX = temp;
		}

		tMinY = ( minimum.y - eye.y ) * rDir.y;
		tMaxY = ( maximum.y - eye.y ) * rDir.y;

		if(dir.y < 0) {
			temp  = tMinY;
			tMinY = tMaxY;
			tMaxY = temp;
		}

		if( tMinX > tMaxY || tMinY > tMaxX)
			outside = false;

		tMinX = max(tMinX,tMinY);
		tMaxX = min(tMaxX,tMaxY);

		tMinZ = ( minimum.z - eye.z ) * rDir.z;
		tMaxZ = ( maximum.z - eye.z ) * rDir.z;

		if(dir.z < 0) {
			temp  = tMinZ;
			tMinZ = tMaxZ;
			tMaxZ = temp;
		} 

		if( tMinX > tMaxZ || tMinZ > tMaxX)
			outside = false;	

		tMinX = max(tMinX,tMinZ);
		tMaxX = min(tMaxX,tMaxZ);
		
		tMinX = max(tMinX,0.0f);

		tMin = tMinX;
		tMax = tMaxX;
		globalMax = tMax;
	};

	int   hitTriangle = -1;
	float closestHit  = FLT_MAX;
	unsigned depth = 0;

	//Traverse grid only if the ray actually hit it
	if(outside) {
		unsigned node = 0;

		while(hitTriangle==-1) {	
			if(tMin == tMax)
				return -1;

			traverse[steps]=node;

			steps++;

			uint2 cell = *(uint2*)grid->nodes[node];
			unsigned type = cell.x & 0x3;

			if(depth == level) {
			glColor3f(1.0f,0.0f,0.0f);
				glBegin(GL_QUADS);
					glVertex3f(minimum.x ,minimum.y ,minimum.z);
					glVertex3f(maximum.x ,minimum.y ,minimum.z);
					glVertex3f(maximum.x ,maximum.y ,minimum.z);
					glVertex3f(minimum.x ,maximum.y ,minimum.z);

					glVertex3f(minimum.x ,minimum.y ,maximum.z);
					glVertex3f(maximum.x ,minimum.y ,maximum.z);
					glVertex3f(maximum.x ,maximum.y ,maximum.z);
					glVertex3f(minimum.x ,maximum.y ,maximum.z);

					glVertex3f(minimum.x ,minimum.y ,minimum.z);
					glVertex3f(maximum.x ,minimum.y ,minimum.z);
					glVertex3f(maximum.x ,minimum.y ,maximum.z);
					glVertex3f(minimum.x ,minimum.y ,maximum.z);

					glVertex3f(minimum.x ,maximum.y ,minimum.z);
					glVertex3f(maximum.x ,maximum.y ,minimum.z);
					glVertex3f(maximum.x ,maximum.y ,maximum.z);
					glVertex3f(minimum.x ,maximum.y ,maximum.z);
				glEnd();
			}

			depth++;

			if(depth > maxDepth)
				maxDepth=depth;

			if(type == LEAF) {
				unsigned count  = cell.x >> 2;
				unsigned offset = cell.y;

				triangleTests += count;

				for(int i=0;i<count;i++) {
					float u,v,t;
					intersectTexture(eye,dir,offset,u,v,t);

					if(v>=-0.00048828125f && u>=-0.00048828125f && u+v<=1.0000304f && t>=0.010070801f && t<=closestHit) {
						closestHit  = t;
						hitTriangle = offset; 
					};

					offset++;
				};

				if(hitTriangle != -1)
					return hitTriangle;
				
				if(tMax >= globalMax) {
					
					for(unsigned i=0;i<steps;i++) {
						printf("%i\n",traverse[i]);
					};

					return -1;
				}

				if(stackCount) {
					stackCount--;
					stackStart = (stackStart-1)&0x3;

					node = stackNode[stackStart];
					tMin = stackMin [stackStart];
					tMax = stackMax [stackStart];

					minimum = stackExtMin[stackStart];
					maximum = stackExtMax[stackStart];
					
				} else {	//Otherwise we must restart from known restart point.
					tMin = tMax;
					tMax = globalMax;
					node = 0;

					minimum = minimumIn;
					maximum = maximumIn;
				};
			} else {
				float split  = *(float*)&cell.y;
				float eyeDim = *(&eye.x + type);
				float dirDim = *(&dir.x + type);
				float tHit  = (split - eyeDim)/dirDim;

				Child left,right;
				left.node	 = node + 1;
				left.minimum = minimum;
				left.maximum = maximum;

				right.node	  = cell.x >> 2;
				right.minimum = minimum;
				right.maximum = maximum;

				switch(type) {
					case 0: left.maximum.x = split; right.minimum.x = split; break;
					case 1: left.maximum.y = split; right.minimum.y = split; break;
					case 2: left.maximum.z = split; right.minimum.z = split; break;
				};
	
				Child *first,*second;

				if(eyeDim < split) {
					first   = &left;
					second  = &right;
				} else if(eyeDim > split) {
					first   = &right;
					second  = &left;
				} else if(dirDim < 0.0f) {
					first   = &right;
					second  = &left;
				} else {
					first   = &left;
					second  = &right;
				};

				if(dirDim == 0.0f) 
					tHit = tMin;

				if(tHit >= tMax || tHit<0) {
					node	= first->node;
					minimum = first->minimum;
					maximum = first->maximum;
				} else if(tHit <= tMin) {
					node	= second->node;
					minimum = second->minimum;
					maximum = second->maximum;
				} else {

					stackNode[stackStart] = second->node;
					stackMin [stackStart] = tHit;
					stackMax [stackStart] = tMax;
					stackExtMin[stackStart] = second->minimum;
					stackExtMax[stackStart] = second->maximum;
					stackStart = (stackStart+1) & 0x3;
					stackCount = min(stackCount+1,4);

					node	= first->node;
					minimum = first->minimum;
					maximum = first->maximum;
					tMax = tHit;
				};
			};
		};
	};

	return hitTriangle;
};

__global__ void renderTreeP(float3 eye	   ,float3 upperLeft, float3 dx, float3 dy,
						    float3 minimum ,float3 maximum) {
    float3 dir;
	float3 origin = eye;
	
	//Compute pixel coordinates. The grid is composed of 8x8 blocks.
	unsigned short x = 450;
	unsigned short y = 183;
	
	//Compute ray direction for current pixel. To achive right traversal, use higher precision intrinsic.
	dir.x = upperLeft.x + dx.x*x + dy.x*y;
	dir.y = upperLeft.y + dx.y*x + dy.y*y;
	dir.z = upperLeft.z + dx.z*x + dy.z*y;

	//Traverse the grid and try to find intersection.
	int hitTriangle = traverseKdTree(origin,dir,minimum,maximum);
};

void cudaRenderKd(unsigned int width,unsigned int height,
				    float3 &minimum, float3 &maximum,CameraCuda &camera) {
	float3 eye,upperLeft,dx,dy;
	eye = camera.eye;
	upperLeft = camera.upperLeft;
	dx = camera.dx;
	dy = camera.dy;

	renderTreeP(eye,upperLeft,dx,dy,minimum,maximum);
};




#define A
#ifdef A
void drawTree(unsigned node,unsigned depth,float3 mini,float3 maxi) {
	if(depth >= level)
		return;

	KdNode* cell = grid->nodes[node];
	unsigned index = cell->flags & 0x3;

	if(index == LEAF) 
	//if(depth == level-1 && cellIndex == cellTarget) {
	if(node == 39302) {
		glColor3f(0.0f,1.0f,1.0f);

		for(int i=0;i<cell->count >> 2;i++) {
			glBegin(GL_TRIANGLES);
				unsigned a,b,c;
				a = grid->nodeTriangles[cell->faces +i]->a;
				b = grid->nodeTriangles[cell->faces +i]->b;
				c = grid->nodeTriangles[cell->faces +i]->c;

				glVertex3f(grid->transformed[a].x,grid->transformed[a].y,grid->transformed[a].z);
				glVertex3f(grid->transformed[b].x,grid->transformed[b].y,grid->transformed[b].z);
				glVertex3f(grid->transformed[c].x,grid->transformed[c].y,grid->transformed[c].z);
			glEnd();
		};
	};


	//if(depth == level-1) {
	//if(node == 70824) {
	if(node == 39302) {
	   if(mini.x < 0.0f)
		   mini.x = mini.x;

		if(index == LEAF)
			glColor3f(0.0f,1.0f,0.0f);
		else
			glColor3f(1.0f,0.0f,0.0f);

		if(cellIndex == cellTarget) {
			glColor3f(1.0f,1.0f,0.0f);
			printf("%i\n",node);
		}

		cellIndex++;
		glBegin(GL_QUADS);
			glVertex3f(mini.x ,mini.y ,mini.z);
			glVertex3f(maxi.x ,mini.y ,mini.z);
			glVertex3f(maxi.x ,maxi.y ,mini.z);
			glVertex3f(mini.x ,maxi.y ,mini.z);

			glVertex3f(mini.x ,mini.y ,maxi.z);
			glVertex3f(maxi.x ,mini.y ,maxi.z);
			glVertex3f(maxi.x ,maxi.y ,maxi.z);
			glVertex3f(mini.x ,maxi.y ,maxi.z);

			glVertex3f(mini.x ,mini.y ,mini.z);
			glVertex3f(maxi.x ,mini.y ,mini.z);
			glVertex3f(maxi.x ,mini.y ,maxi.z);
			glVertex3f(mini.x ,mini.y ,maxi.z);

			glVertex3f(mini.x ,maxi.y ,mini.z);
			glVertex3f(maxi.x ,maxi.y ,mini.z);
			glVertex3f(maxi.x ,maxi.y ,maxi.z);
			glVertex3f(mini.x ,maxi.y ,maxi.z);
		glEnd();
	};
	

	ALIGN16	union {
		float3    leftMax;
		float     leftMaxA[3];};
	ALIGN16	union {
		float3    rightMin;
		float     rightMinA[3];};

	leftMax	= maxi;
	rightMin = mini;

//	unsigned index = cell->flags & 0x3;
	if(index == LEAF)
		return;

	leftMaxA [index] = cell->split;
	rightMinA[index] = cell->split;


/*	if(depth != 0 && depth != 2 && depth != 7)
		drawTree(node+1				  ,depth+1,mini,leftMax);
	if(depth != 1 && depth != 3 && depth != 4 && depth != 5 && depth != 6)
		drawTree(cell->rightChild >> 2,depth+1,rightMin,maxi);*/

	//if(depth != 3)
	drawTree(node+1				  ,depth+1,mini,leftMax);
	//if(depth != 0 && depth != 1 && depth != 2 && depth != 4)
	drawTree(cell->rightChild >> 2,depth+1,rightMin,maxi);
}
#endif

//#define B
#ifdef B

void drawCells(unsigned node) {
	KdCell* cell = grid->cells[node];
	unsigned index = cell->flags & 0x3;

	if(index == LEAF) {
		glColor3f(0.0f,1.0f,1.0f);

		for(int i=0;i<cell->count >> 2;i++) {
			//if(i == cellIndex) {
				glBegin(GL_TRIANGLES);
					unsigned a,b,c;
					a = grid->cellTriangles[cell->faces +i]->a;
					b = grid->cellTriangles[cell->faces +i]->b;
					c = grid->cellTriangles[cell->faces +i]->c;

					glVertex3f(grid->transformed[a].x,grid->transformed[a].y,grid->transformed[a].z);
					glVertex3f(grid->transformed[b].x,grid->transformed[b].y,grid->transformed[b].z);
					glVertex3f(grid->transformed[c].x,grid->transformed[c].y,grid->transformed[c].z);
				glEnd();
			//}
		};
	} else {
		drawCells(node+1);
		drawCells(cell->rightChild >> 2);
	};
};

using std::min;
using std::max;

bool drawTree(unsigned node,unsigned depth,float3 mini,float3 maxi) {
//	if(depth >= level)
//		return false;

	KdCell* cell = grid->cells[node];
	unsigned index = cell->flags & 0x3;

	ALIGN16	union {
		float3    leftMax;
		float     leftMaxA[3];};
	ALIGN16	union {
		float3    rightMin;
		float     rightMinA[3];};

	leftMax	= maxi;
	rightMin = mini;

	if(index == LEAF) {
		if(node == 226932) {
		//if(node == 226914) {
			glColor3f(0.0f,1.0f,0.0f);

			glBegin(GL_TRIANGLES);
			for(int i=0;i<cell->count >> 2;i++) {
				//if(cellTarget == i) {
						unsigned a,b,c;
						a = grid->cellTriangles[cell->faces +i]->a;
						b = grid->cellTriangles[cell->faces +i]->b;
						c = grid->cellTriangles[cell->faces +i]->c;

						glVertex3f(grid->transformed[a].x,grid->transformed[a].y,grid->transformed[a].z);
						glVertex3f(grid->transformed[b].x,grid->transformed[b].y,grid->transformed[b].z);
						glVertex3f(grid->transformed[c].x,grid->transformed[c].y,grid->transformed[c].z);

						float zmin = min(min(grid->transformed[a].z,grid->transformed[b].z),grid->transformed[c].z);
						float zmax = max(max(grid->transformed[a].z,grid->transformed[b].z),grid->transformed[c].z);
						printf("%f %f\n",zmin,zmax);
				//};
			};
			glEnd();

			if(index == LEAF)
				glColor3f(0.0f,1.0f,0.0f);
			else
				glColor3f(1.0f,0.0f,0.0f);

		/*	if(cellIndex == cellTarget) 
				glColor3f(1.0f,1.0f,0.0f);
			cellIndex++;*/

			glBegin(GL_QUADS);
				glVertex3f(mini.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,mini.z);
				glVertex3f(mini.x ,maxi.y ,mini.z);

				glVertex3f(mini.x ,mini.y ,maxi.z);
				glVertex3f(maxi.x ,mini.y ,maxi.z);
				glVertex3f(maxi.x ,maxi.y ,maxi.z);
				glVertex3f(mini.x ,maxi.y ,maxi.z);

				glVertex3f(mini.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,maxi.z);
				glVertex3f(mini.x ,mini.y ,maxi.z);

				glVertex3f(mini.x ,maxi.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,maxi.z);
				glVertex3f(mini.x ,maxi.y ,maxi.z);
			glEnd();

			return true;
		} else {
			return false;
		};
	};

	leftMaxA [index] = cell->split;
	rightMinA[index] = cell->split;


	bool l = drawTree(node+1				  ,depth+1,mini,leftMax);
	bool r = drawTree(cell->rightChild >> 2,depth+1,rightMin,maxi);

	if(l | r) {
		if(depth == level-1) {

			drawCells(node+1);
			drawCells(cell->rightChild >> 2);

			if(index == LEAF)
				glColor3f(0.0f,1.0f,0.0f);
			else
				glColor3f(1.0f,0.0f,0.0f);

		/*	if(cellIndex == cellTarget) 
				glColor3f(1.0f,1.0f,0.0f);
			cellIndex++;*/

			glBegin(GL_QUADS);
				glVertex3f(mini.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,mini.z);
				glVertex3f(mini.x ,maxi.y ,mini.z);

				glVertex3f(mini.x ,mini.y ,maxi.z);
				glVertex3f(maxi.x ,mini.y ,maxi.z);
				glVertex3f(maxi.x ,maxi.y ,maxi.z);
				glVertex3f(mini.x ,maxi.y ,maxi.z);

				glVertex3f(mini.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,maxi.z);
				glVertex3f(mini.x ,mini.y ,maxi.z);

				glVertex3f(mini.x ,maxi.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,maxi.z);
				glVertex3f(mini.x ,maxi.y ,maxi.z);
			glEnd();
		};
	};

	return l | r;
}
#endif

void render() {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0,1.5f,0.1f,80.0f);
	//glOrtho(-3.0f,3.0f,-3.0f,3.0f,0.1f,80.0f);


	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();

	glScalef(-1.0f,1.0f,1.0f);

	//glTranslatef(0.0f,-0.11f,-0.3f);
	//glTranslatef(0.0f,0.0f,-0.8f);
	//glTranslatef(0.26f,0.0f,-0.25f);
	//glTranslatef(0.25f,0.2f,-0.2f);

	#ifdef SPHERES
		glTranslatef(0.0f,0.0f,-0.8f);
	#endif
	#ifdef BUNNY
		//glTranslatef(0.0f,-0.11f,-0.2f);
		//glTranslatef(0.0f,-0.11f,-0.1f);
		//glTranslatef(0.0f,0.0f,-0.23f);

		glRotatef(angleX*PI2A,0.0f,1.0f,0.0f);
		//glTranslatef(-3.0f,-2.5f,posZ);
		//glTranslatef(-4.6f, -0.40f,posZ);
		glTranslatef(-4.6f, -0.55f,posZ);
		//glTranslatef(0.13798390f,-10.8903166,6.1310115);
		//glTranslatef(0.13798390f,-10.8903166,posZ);

		//glTranslatef(0.0f,0.0f,-18.0f);
		//glRotatef(90,1.0f,0.0f,0.0f);

		//glTranslatef(-4500.0f,-1727.0f, -1044.0f);
		//glTranslatef(4500.0f,2000.0f, 0.0f);
		//glRotatef(angleX*PI2A,0.0f,1.0f,0.0f);
		//glTranslatef(0.0f,1727.0f, 1044.0f);

	#endif
	//glTranslatef(0.0f,-0.130f,-0.16f);
//	glRotatef(angleX*PI2A,0.0f,1.0f,0.0f);

/*	glTranslatef(0.0f,0.0f,-0.3f);
	glRotatef(-90.0f,1.0f,0.0f,0.0f);
	glRotatef(angleX*PI2A,1.0f,0.0f,0.0f);
	glTranslatef(0.25f,0.0f,0.0f);*/

	//glTranslatef(0.0f,-0.10f,-0.075f);
	//glRotatef(angleX*PI2A,0.0f,1.0f,0.0f);

	//glTranslatef(0.0f,-0.11f,-0.05f);

	//glTranslatef(0.0f,-0.11f,-0.1f);

	//gluLookAt(eyex+0.25f*dirx,eyey+0.25f*diry,eyez+0.25f*dirz,eyex+dirx,eyey+diry,eyez+dirz,0.0f,1.0f,0.0f);

	glColor3f(1.0f,1.0f,1.0f);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	//glDisable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	//glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

	//glShadeModel(GL_FLAT);

	glEnable(GL_VERTEX_ARRAY);
	glEnable(GL_NORMAL_ARRAY);
	glVertexPointer(4,GL_FLOAT,0,grid->transformed);
	glNormalPointer(GL_FLOAT,16,grid->normals);
	glDrawElements(GL_TRIANGLES,grid->facesSum*3,GL_UNSIGNED_INT,bla);

	glDisable(GL_DEPTH_TEST);
	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	glDisable(GL_LIGHTING);

	cellIndex = 0;
	drawTree(0,0,grid->mini,grid->maxi);

//	cudaRenderKd(512,512,grid->mini,grid->maxi,cameraCuda);

	glEnable(GL_LIGHTING);
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	glEnable(GL_DEPTH_TEST);

	glutSwapBuffers();
};

void dumpMainHeap() {
	//HANDLE default_heap = ::GetProcessHeap ();
	HANDLE default_heap = (HANDLE) _get_heap_handle ();
	PROCESS_HEAP_ENTRY entry;
	memset (&entry, 0, sizeof (entry));
	int count = 0;
	while (::HeapWalk (default_heap, &entry)) 
		if (entry.wFlags & PROCESS_HEAP_ENTRY_BUSY) {
			//if(count > 90)
				printf (" Allocated entry %d: size: %d, overhead: %d.\n", count, entry.cbData, entry.cbOverhead);
			count++;
		}
};

int main(int argc,char** argv) {
//	dumpMainHeap();

	*(unsigned*)&eyex = 0x3f4ccccd;
	*(unsigned*)&eyey = 0x00000000;
	*(unsigned*)&eyez = 0x3e99999a;
	*(unsigned*)&dirx = 0xbf840cc4;
	*(unsigned*)&diry = 0xbba7d300;
	*(unsigned*)&dirz = 0xbdc69448;
	*(unsigned*)&p1x = 0xbe87a4aa;
	*(unsigned*)&p1y = 0xbbad3d51;
	*(unsigned*)&p1z = 0x3e4cb4e0;
	*(unsigned*)&p2x = 0xbe89e7ff;
	*(unsigned*)&p2y = 0xbbae1490;
	*(unsigned*)&p2z = 0x3e4c677a;

		

	/*bunny = loader.loadFile("e:\\bun_zipper.ply");

	Transformation* trans = new Transformation();
	trans->IdentityMatrix();

	Scene scene;
	scene.push_back(ObjectInstance(trans,bunny));*/
/*
	dumpMainHeap();

	_CrtMemState s1,s2,s3;
	_CrtMemCheckpoint( &s1 );

	{
	GrowArray<Triangle> cellTriangles(512);
	TailPool<unsigned>  cellPrimitives(1024);

	srand(time(0));

	unsigned data[10000];
	for(int i=0;i<10000;i++)
		data[i] = rand() % 100;

	dumpMainHeap();

	for(int i=0;i<10000;i++) {
		unsigned* a=cellPrimitives.getMem(data[i]);
		memset(a,0,data[i]*4);
	};

	dumpMainHeap();

	for(int i=0;i<512;i++) {
		unsigned a = cellTriangles.getNext();
		cellTriangles[a]->a=0;
		cellTriangles[a]->b=0;
		cellTriangles[a]->c=0;
	}

	for(int i=9999;i>=5000;i--)
		cellPrimitives.returnMem(data[i]);

	unsigned *bla = new unsigned[17548];
	memset(bla,0,17548*4);

	for(int i=5000;i<10000;i++) {
		unsigned* a=cellPrimitives.getMem(data[i]);
		memset(a,0,data[i]*4);
	};

	for(int i=0;i<512;i++) {
		unsigned a = cellTriangles.getNext();
		cellTriangles[a]->a=0;
		cellTriangles[a]->b=0;
		cellTriangles[a]->c=0;
	}

	dumpMainHeap();

	for(int i=9999;i>=0;i--)
		cellPrimitives.returnMem(data[i]);

	delete bla;

	}

	_CrtMemCheckpoint( &s2 );	
	_CrtMemDifference( &s3, &s1, &s2);
	_CrtMemDumpStatistics( &s3 );

	dumpMainHeap();
*/
	#ifdef SPHERES
	PlyLoader loader;
	Object* bunny = loader.loadFile("e:\\sphere2.ply");
	Transformation* trans = new Transformation();
	trans->IdentityMatrix();
	trans->scale(0.5f,0.5f,0.5f);
	trans->translate(0.25f,0.0f,0.0f);

	Scene scene;
	scene.push_back(ObjectInstance(trans,bunny));

	trans = new Transformation();
	trans->IdentityMatrix();
	trans->translate(-0.25f,0.0f,0.0f);
	scene.push_back(ObjectInstance(trans,bunny));

	SPVector eye	(0.0f,0.0f,0.8f,1.0f);
	SPVector target	(0.0f,0.0f,0.0f,1.0f);
	#endif

	#ifdef BUNNY
	//PlyLoader loader;
	//Object* bunny = loader.loadFile("e:\\bun_zipper.ply");
	//Object* bunny = loader.loadFile("E:/My Work/Skola/data/dragon.ply");

	//MyLoader loader;
	//Object* bunny = loader.loadFile("e:\\soda.mdl");


	//Scene* scene = SceneLoader::instance()->loadScene("e:\\bun_zipper.ply");
	//Scene* scene = SceneLoader::instance()->loadScene("e:\\museum.mdl");
	//Scene* scene = SceneLoader::instance()->loadScene("e:\\robots.mdl");

	//Scene* scene = SceneLoader::instance()->loadScene("e:/kitchen.mdl");
	Scene* scene = SceneLoader::instance()->loadScene("E:/My Work/Skola/Diplomka/Release/scenes/conference.iv");
	#endif

//	dumpMainHeap();

	clock_t start,stop;
	start = clock();
	grid = new KdTree(*scene);
	stop  = clock();
	printf("bla %f\n",(double)(stop-start)/CLOCKS_PER_SEC);

	printf("nodes %i\n",grid->nodes.size());
	printf("references %i\n",grid->nodeTriangles.size());

	float distance = std::max(grid->maxi.x - grid->mini.x,grid->maxi.y - grid->mini.y)*1.5f;

	/*SPVector eye   (0.0f,0.0f,distance,1.0f);
	SPVector up	   (0.0f,1.0f,0.0f,0.0f);
	SPVector target(0.0f,0.0f,0.0f,1.0f);*/

	/*SPVector eye   (0.0f,1.8f,-9.0,1.0f);
	SPVector up	   (0.0f,1.0f,0.0f,0.0f);
	SPVector target(0.0f,0.0f,0.0f,1.0f);*/

	/*SPVector eye   (-0.13798390f,1.8903166f,-6.1310115,1.0f);
	SPVector up	   (0.0f,1.0f,0.0f,0.0f);
	SPVector target(0.072185367f,0.0f,0.99739122f,1.0f);
	target+=eye;*/


	SPVector eye   (3.75f,2.3f,3.6f,1.0f);
	SPVector up	   (-0.31346434f,-0.41981429f,-0.85176057f,0.0f);
	SPVector target(-0.12700307f,0.90744376f,-0.40051973f,1.0f);
	target+=eye;


	//return 1;

	/*unsigned histo[20];
	memset(histo,0,20*4);

	unsigned leafCount = 0;
	unsigned maxFaces = 0;
	for(int i=0;i<grid->cells.size();i++) {
		if((grid->cells[i]->flags & 0x3) == LEAF) {
			leafCount++;
			unsigned cellCount = grid->cells[i]->count>>2;
			if(cellCount > maxFaces)
				maxFaces = cellCount;

			histo[cellCount]++;
		}
	};*/

	Camera camera;

	camera.setUpProjection(512,512,1.0f);
	camera.setLook(eye,target,up);

	camera.prepareCuda(cameraCuda);

//	dumpMainHeap();

	bla = new unsigned[grid->facesSum*3];
	for(int i=0;i<grid->facesSum;i++) {
		bla[3*i]   = grid->triangles[i].a;
		bla[3*i+1] = grid->triangles[i].b;
		bla[3*i+2] = grid->triangles[i].c;
	};

	glutInit(&argc,argv);
	glutInitWindowSize(512,512);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("Visualisation");

	glutDisplayFunc(render);
	glutKeyboardFunc(keyDown);
	glutSpecialFunc(keyDownSpec);

	glutMainLoop();
};
#endif

//#define BVHVIS
#ifdef  BVHVIS
#include <windows.h>
#include <gl/gl.h>
#include <gl/glut.h>

#include <iostream>
#include <cstdlib>
#include <ctime>

#include "FormatImport/PlyLoader.h"
#include "Partitoning/UniformGrid.h"
#include "Partitoning/KdTree.h"
#include "Partitoning/Bvh.h"
#include "Camera.h"

using std::min;
using std::max;

Object* bunny;
Bvh* grid;
unsigned *bla;

int x=56,y=32,z=17;
float angleX;

const float PI2  = 6.283185307179586476925286766559f;
const float PI2A = 57.295779513082320876798154814105f;

float eyex,eyey,eyez;
float dirx,diry,dirz;
float p1x,p1y,p1z;
float p2x,p2y,p2z;

unsigned level = 0;
unsigned cellIndex  = 0;
unsigned cellTarget = 0;
//unsigned cellTarget = 50;

CameraCuda cameraCuda;

void keyDown(unsigned char key, int q, int w) {
	if(key == 'a') level--;
	if(key == 'd') level++;
	glutPostRedisplay();
};

void keyDownSpec(int key, int q, int w) {
	switch(key) {
		case GLUT_KEY_LEFT:	 angleX+=0.1; if(angleX>=PI2) angleX-=PI2; break;
		case GLUT_KEY_RIGHT: angleX-=0.1; if(angleX<0)    angleX+=PI2; break;
		case GLUT_KEY_UP   : cellTarget++; break;
		case GLUT_KEY_DOWN : cellTarget--; break;
	};
	glutPostRedisplay();
};

unsigned indices[] = {
	2531, 2595, 2596,
	2531, 2596, 2532,
	2532, 2596, 2597,
	2532, 2597, 2533,
	2533, 2597, 2598,
	2533, 2598, 2534,
	2534, 2598, 2599,
	2530, 2595, 2531};

#include <float.h>

struct Child {
	unsigned node;
	float3	 minimum;
	float3   maximum;
};

void intersectTexture(float3 &eye,float3 &dir,unsigned offset,float &u,float &v,float &t) {
	unsigned a=grid->cellTriangles[offset]->a;
	unsigned b=grid->cellTriangles[offset]->b;
	unsigned c=grid->cellTriangles[offset]->c;
	
	SPVector v0 = grid->transformed[a];
	SPVector v1 = grid->transformed[b];
	SPVector v2 = grid->transformed[c];

	v2 -= v0;
	v1 -= v0;

	SPVector eye2(eye.x,eye.y,eye.z);
	SPVector dir2(dir.x,dir.y,dir.z);

	SPVector tvec   = eye2 - v0;
	SPVector pvec   = dir2 % v2;
	float  invDet = 1.0f / (v1*pvec);

	u = (tvec*pvec)*invDet;

	SPVector qvec = tvec % v1;
	t = (v2*qvec)*invDet;
	v = (dir2*qvec)*invDet;
};

unsigned maxDepth = 0;
unsigned triangleTests =0;
unsigned steps = 0;

bool intersectBox(float3 &minimum,float3 &maximum,float3 &eye,float3 &dir,float &tMin,float &tMax) {
	// Kay and Kayjia ray-box intersection test as descibed in "An introduction to Ray Tracing" by A.S.Glassner
	float tMinX,tMinY,tMinZ;
	float tMaxX,tMaxY,tMaxZ;
	float temp;

	bool  hit = true;

	//Speed by division by using the resiprocal. 
	float3 rDir;
	rDir.x=1.0f/dir.x;
	rDir.y=1.0f/dir.y;
	rDir.z=1.0f/dir.z;

	tMinX = ( minimum.x - eye.x ) * rDir.x;
	tMaxX = ( maximum.x - eye.x ) * rDir.x;

	if(dir.x < 0) {		//Swap the values instead of computing in the branche. Should spend less time in divergent branches.
		temp  = tMinX;
		tMinX = tMaxX;
		tMaxX = temp;
	}

	tMinY = ( minimum.y - eye.y ) * rDir.y;
	tMaxY = ( maximum.y - eye.y ) * rDir.y;

	if(dir.y < 0) {
		temp  = tMinY;
		tMinY = tMaxY;
		tMaxY = temp;
	}

	if( tMinX > tMaxY || tMinY > tMaxX)
		hit = false;

	tMinX = max(tMinX,tMinY);
	tMaxX = min(tMaxX,tMaxY);

	tMinZ = ( minimum.z - eye.z ) * rDir.z;
	tMaxZ = ( maximum.z - eye.z ) * rDir.z;

	if(dir.z < 0) {
		temp  = tMinZ;
		tMinZ = tMaxZ;
		tMaxZ = temp;
	} 

	if( tMinX > tMaxZ || tMinZ > tMaxX)
		hit = false;	

	tMinX = max(tMinX,tMinZ);
	tMaxX = min(tMaxX,tMaxZ);
	
	tMinX = max(tMinX,0.0f);

	tMin = tMinX;
	tMax = tMaxX;

	return hit;
};

int traverseBvh(float3 &eye,float3 &dir) {
	BvhCell		cellLeft,cellRight;
	unsigned	stack[64];
	unsigned	stackPos = 0;

	BvhCell  *current = &cellLeft;

	unsigned node  = 0;
	int      hitTriangle = -1;
	float    closestHit  = FLT_MAX;

	unsigned depth = 0;

	cellLeft = *grid->cells[node];

	while(true) {
		if(current->childFlags & 1) {
			//leaf
			unsigned count  = current->count;
			unsigned offset = current->childFlags>>1;

			for(int i=0;i<count;i++) {
				float u,v,t;
				intersectTexture(eye,dir,offset,u,v,t);

				if(v>=-0.00048828125f && u>=-0.00048828125f && u+v<=1.0000304f && t>=0.010070801f && t<=closestHit) {
					closestHit  = t;
					hitTriangle = offset; 
				};

				offset++;
			};

			if(stackPos>0) {
				node = stack[--stackPos];

				current = &cellLeft;

				cellLeft = *grid->cells[node];
			} else 
				return hitTriangle;
		} else {
			if(depth == level) {
			glColor3f(1.0f,0.0f,0.0f);
				glBegin(GL_QUADS);
					glVertex3f(current->minimum.x ,current->minimum.y ,current->minimum.z);
					glVertex3f(current->maximum.x ,current->minimum.y ,current->minimum.z);
					glVertex3f(current->maximum.x ,current->maximum.y ,current->minimum.z);
					glVertex3f(current->minimum.x ,current->maximum.y ,current->minimum.z);

					glVertex3f(current->minimum.x ,current->minimum.y ,current->maximum.z);
					glVertex3f(current->maximum.x ,current->minimum.y ,current->maximum.z);
					glVertex3f(current->maximum.x ,current->maximum.y ,current->maximum.z);
					glVertex3f(current->minimum.x ,current->maximum.y ,current->maximum.z);

					glVertex3f(current->minimum.x ,current->minimum.y ,current->minimum.z);
					glVertex3f(current->maximum.x ,current->minimum.y ,current->minimum.z);
					glVertex3f(current->maximum.x ,current->minimum.y ,current->maximum.z);
					glVertex3f(current->minimum.x ,current->minimum.y ,current->maximum.z);

					glVertex3f(current->minimum.x ,current->maximum.y ,current->minimum.z);
					glVertex3f(current->maximum.x ,current->maximum.y ,current->minimum.z);
					glVertex3f(current->maximum.x ,current->maximum.y ,current->maximum.z);
					glVertex3f(current->minimum.x ,current->maximum.y ,current->maximum.z);
				glEnd();
			}
			depth++;

			unsigned leftNode  = node+1;
			unsigned rightNode = current->childFlags>>1;

			cellLeft  = *grid->cells[leftNode];
			cellRight = *grid->cells[rightNode];
			//Internal node

			float leftMin ,leftMax;
			float rightMin,rightMax;
			intersectBox(cellLeft.minimum ,cellLeft.maximum ,eye,dir,leftMin ,leftMax );
			intersectBox(cellRight.minimum,cellRight.maximum,eye,dir,rightMin,rightMax);

			int wantLeft  = (leftMin  < leftMax ) && (leftMin  < closestHit) && (leftMax >=0);
			int wantRight = (rightMin < rightMax) && (rightMin < closestHit) && (rightMax>=0);

			if(wantLeft && wantRight) {
				bool firstLeft = leftMin<rightMin;
				
				unsigned push;
				if(firstLeft) {
					current = &cellLeft;
					node    = leftNode;
					push	= rightNode;
				} else {
					current = &cellRight;
					node    = rightNode;
					push	= leftNode;
				};
				
				stack[stackPos++] = push;
			}
			else if(wantRight) { current = &cellRight; node = rightNode;}
			else if(wantLeft ) { current = &cellLeft;  node = leftNode;}
			else {
				if(stackPos>0) {
					node = stack[--stackPos];
					current = &cellLeft;
					cellLeft = *grid->cells[node];
				} else 
					return hitTriangle;
			};
		};
	};
};

void renderTreeP(float3 eye	   ,float3 upperLeft, float3 dx, float3 dy) {
    float3 dir;
	float3 origin = eye;
	
	//Compute pixel coordinates. The grid is composed of 8x8 blocks.
	unsigned short x = 400;
	unsigned short y = 240;
	
	//Compute ray direction for current pixel. To achive right traversal, use higher precision intrinsic.
	dir.x = upperLeft.x + dx.x*x + dy.x*y;
	dir.y = upperLeft.y + dx.y*x + dy.y*y;
	dir.z = upperLeft.z + dx.z*x + dy.z*y;

	//Traverse the grid and try to find intersection.
	int hitTriangle = traverseBvh(origin,dir);
};

void cudaRenderBvh(unsigned int width,unsigned int height,CameraCuda &camera) {
	float3 eye,upperLeft,dx,dy;
	eye = camera.eye;
	upperLeft = camera.upperLeft;
	dx = camera.dx;
	dy = camera.dy;

	renderTreeP(eye,upperLeft,dx,dy);
};

#define A
#ifdef A
void drawTree(unsigned node,unsigned depth) {
	if(depth >= level)
		return;

	BvhCell* cell = grid->cells[node];


	bool leaf = cell->childFlags & 0x1;

/*	if(node == 121 || node == 119 || node == 117 || node == 115 || node == 113 ||
	   node == 111 || node == 110 || node == 109 || node == 108 || node == 107 || 
	   node == 87  || node == 86  || node == 85) {*/

	float3 mini = cell->minimum;
	float3 maxi = cell->maximum;

	if(depth == level-1) {

		if(leaf)
			glColor3f(0.0f,1.0f,0.0f);
		else
			glColor3f(1.0f,0.0f,0.0f);

		if(cellIndex == cellTarget) 
			glColor3f(1.0f,1.0f,0.0f);

		cellIndex++;
		glBegin(GL_QUADS);
			glVertex3f(mini.x ,mini.y ,mini.z);
			glVertex3f(maxi.x ,mini.y ,mini.z);
			glVertex3f(maxi.x ,maxi.y ,mini.z);
			glVertex3f(mini.x ,maxi.y ,mini.z);

			glVertex3f(mini.x ,mini.y ,maxi.z);
			glVertex3f(maxi.x ,mini.y ,maxi.z);
			glVertex3f(maxi.x ,maxi.y ,maxi.z);
			glVertex3f(mini.x ,maxi.y ,maxi.z);

			glVertex3f(mini.x ,mini.y ,mini.z);
			glVertex3f(maxi.x ,mini.y ,mini.z);
			glVertex3f(maxi.x ,mini.y ,maxi.z);
			glVertex3f(mini.x ,mini.y ,maxi.z);

			glVertex3f(mini.x ,maxi.y ,mini.z);
			glVertex3f(maxi.x ,maxi.y ,mini.z);
			glVertex3f(maxi.x ,maxi.y ,maxi.z);
			glVertex3f(mini.x ,maxi.y ,maxi.z);
		glEnd();
		   };

	if(leaf)
		return;


	if(depth != 0)
	drawTree(node+1				  ,depth+1);
	drawTree(cell->childFlags >> 1,depth+1);
}
#endif

//#define B
#ifdef B

void drawCells(unsigned node) {
	KdCell* cell = grid->cells[node];
	unsigned index = cell->flags & 0x3;

	if(index == LEAF) {
		glColor3f(0.0f,1.0f,1.0f);

		for(int i=0;i<cell->count >> 2;i++) {
			//if(i == cellIndex) {
				glBegin(GL_TRIANGLES);
					unsigned a,b,c;
					a = grid->cellTriangles[cell->faces +i]->a;
					b = grid->cellTriangles[cell->faces +i]->b;
					c = grid->cellTriangles[cell->faces +i]->c;

					glVertex3f(grid->transformed[a].x,grid->transformed[a].y,grid->transformed[a].z);
					glVertex3f(grid->transformed[b].x,grid->transformed[b].y,grid->transformed[b].z);
					glVertex3f(grid->transformed[c].x,grid->transformed[c].y,grid->transformed[c].z);
				glEnd();
			//}
		};
	} else {
		drawCells(node+1);
		drawCells(cell->rightChild >> 2);
	};
};

using std::min;
using std::max;

bool drawTree(unsigned node,unsigned depth,float3 mini,float3 maxi) {
//	if(depth >= level)
//		return false;

	KdCell* cell = grid->cells[node];
	unsigned index = cell->flags & 0x3;

	ALIGN16	union {
		float3    leftMax;
		float     leftMaxA[3];};
	ALIGN16	union {
		float3    rightMin;
		float     rightMinA[3];};

	leftMax	= maxi;
	rightMin = mini;

	if(index == LEAF) {
		if(node == 226932) {
		//if(node == 226914) {
			glColor3f(0.0f,1.0f,0.0f);

			glBegin(GL_TRIANGLES);
			for(int i=0;i<cell->count >> 2;i++) {
				//if(cellTarget == i) {
						unsigned a,b,c;
						a = grid->cellTriangles[cell->faces +i]->a;
						b = grid->cellTriangles[cell->faces +i]->b;
						c = grid->cellTriangles[cell->faces +i]->c;

						glVertex3f(grid->transformed[a].x,grid->transformed[a].y,grid->transformed[a].z);
						glVertex3f(grid->transformed[b].x,grid->transformed[b].y,grid->transformed[b].z);
						glVertex3f(grid->transformed[c].x,grid->transformed[c].y,grid->transformed[c].z);

						float zmin = min(min(grid->transformed[a].z,grid->transformed[b].z),grid->transformed[c].z);
						float zmax = max(max(grid->transformed[a].z,grid->transformed[b].z),grid->transformed[c].z);
						printf("%f %f\n",zmin,zmax);
				//};
			};
			glEnd();

			if(index == LEAF)
				glColor3f(0.0f,1.0f,0.0f);
			else
				glColor3f(1.0f,0.0f,0.0f);

		/*	if(cellIndex == cellTarget) 
				glColor3f(1.0f,1.0f,0.0f);
			cellIndex++;*/

			glBegin(GL_QUADS);
				glVertex3f(mini.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,mini.z);
				glVertex3f(mini.x ,maxi.y ,mini.z);

				glVertex3f(mini.x ,mini.y ,maxi.z);
				glVertex3f(maxi.x ,mini.y ,maxi.z);
				glVertex3f(maxi.x ,maxi.y ,maxi.z);
				glVertex3f(mini.x ,maxi.y ,maxi.z);

				glVertex3f(mini.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,maxi.z);
				glVertex3f(mini.x ,mini.y ,maxi.z);

				glVertex3f(mini.x ,maxi.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,maxi.z);
				glVertex3f(mini.x ,maxi.y ,maxi.z);
			glEnd();

			return true;
		} else {
			return false;
		};
	};

	leftMaxA [index] = cell->split;
	rightMinA[index] = cell->split;


	bool l = drawTree(node+1				  ,depth+1,mini,leftMax);
	bool r = drawTree(cell->rightChild >> 2,depth+1,rightMin,maxi);

	if(l | r) {
		if(depth == level-1) {

			drawCells(node+1);
			drawCells(cell->rightChild >> 2);

			if(index == LEAF)
				glColor3f(0.0f,1.0f,0.0f);
			else
				glColor3f(1.0f,0.0f,0.0f);

		/*	if(cellIndex == cellTarget) 
				glColor3f(1.0f,1.0f,0.0f);
			cellIndex++;*/

			glBegin(GL_QUADS);
				glVertex3f(mini.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,mini.z);
				glVertex3f(mini.x ,maxi.y ,mini.z);

				glVertex3f(mini.x ,mini.y ,maxi.z);
				glVertex3f(maxi.x ,mini.y ,maxi.z);
				glVertex3f(maxi.x ,maxi.y ,maxi.z);
				glVertex3f(mini.x ,maxi.y ,maxi.z);

				glVertex3f(mini.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,mini.z);
				glVertex3f(maxi.x ,mini.y ,maxi.z);
				glVertex3f(mini.x ,mini.y ,maxi.z);

				glVertex3f(mini.x ,maxi.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,mini.z);
				glVertex3f(maxi.x ,maxi.y ,maxi.z);
				glVertex3f(mini.x ,maxi.y ,maxi.z);
			glEnd();
		};
	};

	return l | r;
}
#endif

void render() {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45.0,4.0/3.0,0.001f,4.0f);
	//glOrtho(-1.0f,1.0f,-1.0f,1.0f,0.001f,4.0f);


	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();

	glScalef(-1.0f,1.0f,1.0f);

	//glTranslatef(0.0f,-0.11f,-0.3f);
	//glTranslatef(0.0f,0.0f,-0.8f);
	//glTranslatef(0.26f,0.0f,-0.25f);
	//glTranslatef(0.25f,0.2f,-0.2f);

	#ifdef SPHERES
		glTranslatef(0.0f,0.0f,-0.8f);
	#endif
	#ifdef BUNNY
		glTranslatef(0.0f,-0.11f,-0.2f);
	#endif
	//glTranslatef(0.0f,-0.130f,-0.16f);
	glRotatef(angleX*PI2A,0.0f,1.0f,0.0f);

	glColor3f(1.0f,1.0f,1.0f);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	//glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

	glShadeModel(GL_FLAT);

	glEnable(GL_VERTEX_ARRAY);
	glEnable(GL_NORMAL_ARRAY);
	//glVertexPointer(4,GL_FLOAT,0,bunny->vertices);
	glVertexPointer(4,GL_FLOAT,0,grid->transformed);
	glNormalPointer(GL_FLOAT,16,grid->normals);
	glDrawElements(GL_TRIANGLES,grid->facesSum*3,GL_UNSIGNED_INT,bla);

	glDisable(GL_DEPTH_TEST);
	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	glDisable(GL_LIGHTING);

	cellIndex = 0;
//	drawTree(0,0);

	//cudaRenderKd(640,480,grid->mini,grid->maxi,cameraCuda);
	cudaRenderBvh(640,480,cameraCuda);

	glEnable(GL_LIGHTING);
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	glEnable(GL_DEPTH_TEST);

	glutSwapBuffers();
};

void dumpMainHeap() {
	//HANDLE default_heap = ::GetProcessHeap ();
	HANDLE default_heap = (HANDLE) _get_heap_handle ();
	PROCESS_HEAP_ENTRY entry;
	memset (&entry, 0, sizeof (entry));
	int count = 0;
	while (::HeapWalk (default_heap, &entry)) 
		if (entry.wFlags & PROCESS_HEAP_ENTRY_BUSY) {
			//if(count > 90)
				printf (" Allocated entry %d: size: %d, overhead: %d.\n", count, entry.cbData, entry.cbOverhead);
			count++;
		}
};

int main(int argc,char** argv) {
	PlyLoader loader;
	#ifdef SPHERES
	Object* bunny = loader.loadFile("e:\\sphere2.ply");
	Transformation* trans = new Transformation();
	trans->IdentityMatrix();
	trans->scale(0.5f,0.5f,0.5f);
	trans->translate(0.25f,0.0f,0.0f);

	Scene scene;
	scene.push_back(ObjectInstance(trans,bunny));

	trans = new Transformation();
	trans->IdentityMatrix();
	trans->translate(-0.25f,0.0f,0.0f);
	scene.push_back(ObjectInstance(trans,bunny));

	SPVector eye	(0.0f,0.0f,0.8f,1.0f);
	SPVector target	(0.0f,0.0f,0.0f,1.0f);
	#endif

	#ifdef BUNNY
	Object* bunny = loader.loadFile("e:\\bun_zipper.ply");
	//Object* bunny = loader.loadFile("E:/My Work/Skola/data/dragon.ply");
	Transformation* trans = new Transformation();
	trans->IdentityMatrix();

	Scene scene;
	scene.push_back(ObjectInstance(trans,bunny));

	SPVector eye	(0.0f,0.11f,0.2f,1.0f);
	SPVector target	(0.0f,0.11f,0.0f,1.0f);
	#endif

	clock_t start,stop;
	start = clock();
	grid = new Bvh(scene);
	stop  = clock();
	printf("bla %f\n",(double)(stop-start)/CLOCKS_PER_SEC);

	Camera camera;
	SPVector up		(0.0f,1.0f,0.0f,0.0f);

	camera.setUpProjection(640,480,1.0f);
	camera.setLook(eye,target,up);

	camera.prepareCuda(cameraCuda);

	bla = new unsigned[grid->facesSum*3];
	for(int i=0;i<grid->facesSum;i++) {
		bla[3*i]   = grid->triangles[i].a;
		bla[3*i+1] = grid->triangles[i].b;
		bla[3*i+2] = grid->triangles[i].c;
	};

	glutInit(&argc,argv);
	glutInitWindowSize(800,600);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("Visualisation");

	glutDisplayFunc(render);
	glutKeyboardFunc(keyDown);
	glutSpecialFunc(keyDownSpec);

	glutMainLoop();
};
#endif
